package custom.dao;

import java.sql.*;
import java.io.*;
import java.util.*;
import com.ibatis.common.resources.*;
import com.ibatis.sqlmap.client.*;
import custom.dto.*;

public class CustomDAO {

	private static SqlMapClient sqlmap;
	
	static{
		try{
			String xmlPath="/custom/dao/SqlMapConfig.xml";
			Reader reader=Resources.getResourceAsReader(xmlPath);
			sqlmap=SqlMapClientBuilder.buildSqlMapClient(reader);
		}catch(Exception ex){
			System.out.println("SqlMapConfig Parsing Error()"+ex.getMessage());
		}
	}
	/*
	 * 	ȯ漳(SqlMapConfig.xml) Query.xml 뵵 ؼ ִµ
	 *  iBatis DAOŬ  xmlϵ ؼϰԵȴ. iBatis ̺귯 
	 *  üؼϰ ǹǷ  DOM(DocumentBuilderFactory....) ؼ ʴ´.
	 *  
	 *  ٷ Ʒ  ̷ ؼ XML   DB ҷ  ó ޼ҵ带
	 *  ְ ȴ.
	 *  
	 *  ȯ() ArrayList<CustomDTO> µ CustomDTO ȣ,̸,μ..
	 *  ٹۿ ҷ̱   Ŭ ArrayList ؼ DB  
	 *  ѹ ҷ ȴ.(Ķ) 翬  ʴ´.(ĶͰ ؼ   ҷð ƴϱ⶧..)
	 *  
	 *  queryForList : ArrayList ҷö  ڿ "selectAllData" Query.xml <select>±׿
	 *   id
	 *  
	 *   ϴ DB 系 ҷ .  ٽ ListAction.java ̵!
	 */	
	//erpex2 ̺ ü
	public static ArrayList<CustomDTO> selectAllData() throws SQLException{
		return (ArrayList<CustomDTO>)sqlmap.queryForList("selectAllData");
	}
	
	//erpex2̺ üԽù ȣ +1
	public static Integer getMaxNo()throws SQLException{
		return (Integer)sqlmap.queryForObject("getmaxno");
	}
	
	//erpex2̺ 
	public static void Insert(CustomDTO dto) throws SQLException{
		sqlmap.insert("insert",dto);
	}
	
	//erpex2̺ Խù ȣ  Խù  ҷ 
	public static CustomDTO updateList(int no) throws SQLException{
		return (CustomDTO)sqlmap.queryForObject("updatelist",no);
	}
	
	//erpex2̺ Խù ȣ  Խù  
	public static void Update(CustomDTO dto) throws SQLException{
		sqlmap.update("update",dto);
	}
	
	public static void Delete(int no) throws SQLException{
		sqlmap.delete("delete",no);
	}
}
